"
 COPYRIGHT (c) 1996-2011 by Claus Gittinger

 New code and modifications done at SWING Research Group [1]:

 COPYRIGHT (c) 2010-2011 by Jan Vrany, Jan Kurs and Marcel Hlopko
                            SWING Research Group, Czech Technical University in Prague

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 [1] Code written at SWING Research Group contains a signature
     of one of the above copright owners. For exact set of such code,
     see the differences between this version and version stx:libjava
     as of 1.9.2010
"
"{ Package: 'stx:libjava' }"

AbstractJavaTestCase subclass:#JavaRefTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Tests-RuntimeConstantPool'
!

!JavaRefTests class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1996-2011 by Claus Gittinger

 New code and modifications done at SWING Research Group [1]:

 COPYRIGHT (c) 2010-2011 by Jan Vrany, Jan Kurs and Marcel Hlopko
                            SWING Research Group, Czech Technical University in Prague

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 [1] Code written at SWING Research Group contains a signature
     of one of the above copright owners. For exact set of such code,
     see the differences between this version and version stx:libjava
     as of 1.9.2010

"
! !

!JavaRefTests methodsFor:'javaRef tests'!

testCorrectInstanceCreation
    | javaRef |

    javaRef := JavaRef2 new.
    self assertFalse: (javaRef isResolved).
    self assertTrue: (javaRef valueCache isNil).
    self should: [ javaRef resolve ] raise: SubclassResponsibilityError.
    self should: [ javaRef resolveStatic ] raise: SubclassResponsibilityError.

    "Created: / 08-04-2011 / 11:40:25 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
    "Modified: / 26-04-2011 / 13:21:14 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

testMockedInvalidating
    | javaRefMock |

    javaRefMock := JavaRefMock new.
    self assertFalse: (javaRefMock isResolved).
    self assertTrue: (javaRefMock valueCache isNil).
    self assertTrue: (javaRefMock resolve = 'ok').
    self assertTrue: (javaRefMock isResolved).
    javaRefMock invalidate.
    self assertFalse: (javaRefMock isResolved).
    self assertTrue: (javaRefMock valueCache isNil).
    self assertTrue: (javaRefMock resolveStatic = 'static').
    self assertTrue: (javaRefMock isResolved).
    javaRefMock invalidate.
    self assertFalse: (javaRefMock isResolved).
        self assertTrue: (javaRefMock valueCache isNil).

    "Created: / 08-04-2011 / 11:50:35 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
    "Modified: / 26-04-2011 / 13:21:51 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

testMockedInvalidatingForClassNegative
    | javaRefMock |

    javaRefMock := JavaRefMock new.
    self assertTrue: (javaRefMock isResolved not).
    javaRefMock resolve.
    self assertTrue: (javaRefMock isResolved).
    javaRefMock invalidateForClass: 'Ljava/lang/String;'.
    self assertTrue: (javaRefMock isResolved).
    javaRefMock invalidate.
    self assertTrue: (javaRefMock isResolved not).
    javaRefMock resolveStatic.
    self assertTrue: (javaRefMock isResolved).
    javaRefMock invalidateForClass: 'Ljava/lang/String;'.
    self assertTrue: (javaRefMock isResolved).

    "Created: / 08-04-2011 / 16:19:13 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
    "Modified: / 26-04-2011 / 13:22:46 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

testMockedInvalidatingForClassPositive
    | javaRefMock |

    javaRefMock := JavaRefMock new.
    self assertTrue: (javaRefMock isResolved not).
    javaRefMock resolve.
    self assertTrue: (javaRefMock isResolved).
    javaRefMock invalidateForClass: 'mock'.
    self assertTrue: (javaRefMock isResolved not).
    javaRefMock resolveStatic.
    self assertTrue: (javaRefMock isResolved).
    javaRefMock invalidateForClass: 'mock'.
        self assertTrue: (javaRefMock isResolved not).

    "Created: / 08-04-2011 / 16:19:52 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
    "Modified: / 26-04-2011 / 13:23:13 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

testMockedResolving
    | javaRefMock |

    javaRefMock := JavaRefMock new.
    self assertFalse: (javaRefMock isResolved).
    self assertTrue: (javaRefMock valueCache isNil).
    self assertTrue: (javaRefMock resolve = 'ok').
    self assertTrue: (javaRefMock isResolved).

    "Created: / 08-04-2011 / 11:47:27 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

testMockedResolvingStatic
    | javaRefMock |

    javaRefMock := JavaRefMock new.
    self assertFalse: (javaRefMock isResolved).
    self assertTrue: (javaRefMock valueCache isNil).
    self assertTrue: (javaRefMock resolveStatic = 'static').
    self assertTrue: (javaRefMock isResolved).

    "Created: / 26-04-2011 / 13:23:31 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
! !

!JavaRefTests class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
