"
 Copyright (c) 2010-2011 Jan Vrany, Jan Kurs & Marcel Hlopko,
                         SWING Research Group, Czech Technical University 
                         in Prague

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:libjava/experiments' }"

Object subclass:#MethodCondition
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Experiments-Support'
!

MethodCondition subclass:#And
	instanceVariableNames:'left right'
	classVariableNames:''
	poolDictionaries:''
	privateIn:MethodCondition
!

MethodCondition subclass:#Pass
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	privateIn:MethodCondition
!

MethodCondition subclass:#Type
	instanceVariableNames:'argument type'
	classVariableNames:''
	poolDictionaries:''
	privateIn:MethodCondition
!

!MethodCondition class methodsFor:'documentation'!

copyright
"
 Copyright (c) 2010-2011 Jan Vrany, Jan Kurs & Marcel Hlopko,
                         SWING Research Group, Czech Technical University 
                         in Prague

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

"
! !

!MethodCondition class methodsFor:'instance creation'!

argument: argument type: type

    ^self new argument: argument; type: type

    "Created: / 06-12-2011 / 21:13:19 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

pass

    ^Pass new

    "Created: / 06-12-2011 / 22:24:55 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!MethodCondition methodsFor:'composition'!

and: anotherCondition

    ^And left: self right: anotherCondition

    "Created: / 06-12-2011 / 21:10:00 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!MethodCondition methodsFor:'evaluating'!

evaluateWithReceiver: receiver arguments: arguments

    self subclassResponsibility

    "Created: / 06-12-2011 / 21:25:59 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!MethodCondition::And class methodsFor:'instance creation'!

left: left right: right

    ^self new left: left; right: right

    "Created: / 06-12-2011 / 21:10:43 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!MethodCondition::And methodsFor:'accessing'!

left
    ^ left
!

left:something
    left := something.
!

right
    ^ right
!

right:something
    right := something.
! !

!MethodCondition::And methodsFor:'evaluation'!

evaluateWithReceiver: receiver arguments: arguments

    ^(left evaluateWithReceiver: receiver arguments: arguments)
        and: [right evaluateWithReceiver: receiver arguments: arguments].

    "Created: / 06-12-2011 / 21:26:40 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!MethodCondition::Pass methodsFor:'evaluating'!

evaluateWithReceiver: receiver arguments: arguments

    ^true

    "Created: / 06-12-2011 / 22:26:53 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!MethodCondition::Type methodsFor:'accessing'!

argument
    ^ argument
!

argument:something
    argument := something.
!

type
    ^ type
!

type:something
    type := something.
! !

!MethodCondition::Type methodsFor:'evaluating'!

evaluateWithReceiver: receiver arguments: arguments

    ^ (arguments at: argument) isKindOf: type

    "Created: / 06-12-2011 / 21:28:06 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!MethodCondition class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
