"
 Copyright (c) 2010-2011 Jan Vrany, Jan Kurs & Marcel Hlopko,
                         SWING Research Group, Czech Technical University 
                         in Prague

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:libjava/experiments' }"

TestCase subclass:#PerformanceTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Experiments-Lookup-Tests'
!

!PerformanceTests class methodsFor:'documentation'!

copyright
"
 Copyright (c) 2010-2011 Jan Vrany, Jan Kurs & Marcel Hlopko,
                         SWING Research Group, Czech Technical University 
                         in Prague

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

"
! !

!PerformanceTests methodsFor:'testing'!

_testPerformance
    | objectCount objects loops mc jmc time |
    "Not real Test, just brief overview of performance
        Measure time of method invocation 
            - without parameter on ST object
            - with Java object as a parameter on ST object
            - without parameter on Java object
            - with Java object as a parameter on Java object
        See transcript for results
    "
    objectCount := 100.
    objects := OrderedCollection new.
    loops := 100000.
    mc := PerformanceTestStObject new.
    jmc := (Java classForName:'PerformanceTestObject') new.
    objectCount timesRepeat: [
        objects add: Object new.
    ].

    time := Time millisecondsToRun: [
        loops timesRepeat:[
            mc repeat: objects  atRandom.
        ]
    ].
    Transcript showCR: 'st time with object: ', time asString, 'ms'.

    time := Time millisecondsToRun: [
        loops timesRepeat:[
            objects atRandom.
            mc foo.
        ]
    ].
    Transcript showCR: 'st time no parameter: ', time asString, 'ms'.

    time := Time millisecondsToRun: [
        loops timesRepeat:[
            jmc repeat: objects  atRandom.
        ]
    ].
    Transcript showCR: 'Java time with object: ', time asString, 'ms'.

    time := Time millisecondsToRun: [
        loops timesRepeat:[
            objects atRandom.
            jmc foo.
        ]
    ].
    Transcript showCR: 'Java time no parameter: ', time asString, 'ms'.

    "Modified: / 09-01-2011 / 21:58:53 / Jan Kurs <kurs.jan@post.cz>"
    "Created: / 17-02-2011 / 16:23:38 / kursjan <kursjan@fit.cvut.cz>"
    "Modified: / 21-02-2011 / 11:08:05 / kursjan <kursjan@fit.cvut.cz>"
! !

!PerformanceTests class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
