"
 Copyright (c) 2010-2011 Jan Vrany, Jan Kurs & Marcel Hlopko,
                         SWING Research Group, Czech Technical University 
                         in Prague

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:libjava/experiments' }"

JavaTypeBox subclass:#SetBox
	instanceVariableNames:'javaToSmalltalkSelectors'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Experiments-Types'
!

!SetBox class methodsFor:'documentation'!

copyright
"
 Copyright (c) 2010-2011 Jan Vrany, Jan Kurs & Marcel Hlopko,
                         SWING Research Group, Czech Technical University 
                         in Prague

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

"
! !

!SetBox methodsFor:'accessing'!

box: stSet
    " I don't want to convert, I provide translation between java.util.Set and Smalltalk Set class interfaces"
    ^ stSet

    "Created: / 25-09-2011 / 20:27:50 / Jan Kurs <kursjan@fit.cvut.cz>"
!

initialize
    javaToSmalltalkSelectors := IdentityDictionary new.
    javaToSmalltalkSelectors
        at: #contains
        put: #java__contains:.

    Set compile: 'java__contains:anObject
         ^ self contains: [:el | anObject = el ] ' classified: #javaProtocol

    "Created: / 25-09-2011 / 20:46:57 / Jan Kurs <kursjan@fit.cvut.cz>"
!

javaMessageToSmalltalk: aMessageDescription
    | sel stSel |
    sel := aMessageDescription name asSymbol.
    stSel := javaToSmalltalkSelectors at: sel ifAbsent: [^nil].
    ^ MessageDescription new
        parserClass: SmalltalkSelectorParser;
        selector: stSel;
        returnType: aMessageDescription returnType;
        yourself.

    "Created: / 25-09-2011 / 21:12:00 / Jan Kurs <kursjan@fit.cvut.cz>"
!

javaType
    ^ #'Ljava/util/Set;'

    "Created: / 25-09-2011 / 20:29:11 / Jan Kurs <kursjan@fit.cvut.cz>"
!

smalltalkType
    ^ #Set

    "Created: / 25-09-2011 / 20:29:23 / Jan Kurs <kursjan@fit.cvut.cz>"
!

unbox: javaSet
    ^ javaSet

    "Created: / 25-09-2011 / 20:28:48 / Jan Kurs <kursjan@fit.cvut.cz>"
! !

!SetBox class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
