package stx.libjava.tools.tests;

import static org.junit.Assert.assertEquals;

import java.util.ArrayList;

import org.junit.Test;

import stx.libjava.tools.SyntaxHighlighter;
import stx.libjava.tools.SyntaxHighlighterHandler;

public class SyntaxHighlighterTests  {
	
	public class Handler implements SyntaxHighlighterHandler {
		
		public ArrayList<String> marks = new ArrayList<String>();
			
		@Override
		public void markString(int startPosition, int length) {
			marks.add("string-"+startPosition+"-"+length);			
		}
		
	}
	
	@Test
	public void test_01() {
		Handler handler = new Handler();
		SyntaxHighlighter highlighter = new SyntaxHighlighter(handler);		
		highlighter.parseExpression("\"a\" + \"b\"");
		
		assertEquals(2, 			handler.marks.size());
		assertEquals("string-0-3", 	handler.marks.get(0));
		assertEquals("string-6-3", 	handler.marks.get(1));
		
	}
	
	
	
	
}
