package stx.libjava.tests;

import static org.junit.Assert.fail;
import static org.junit.Assert.*;

import org.apache.catalina.startup.Bootstrap;
import org.junit.Test;

import org.apache.catalina.startup.Catalina;

public class StartAndStopTomcatTests {

	private static final String TOMCAT = "../../libs/tomcat6";
	private Bootstrap bootstrap;

	public Bootstrap getBootstrap() {
		return bootstrap;
	}

	public StartAndStopTomcatTests() {
		bootstrap = new Bootstrap();				
		String tomcatDir = System.getProperty("stx.libjava.tomcat.dir");
		if (tomcatDir == null) {
			bootstrap.setCatalinaHome(TOMCAT);
			//bootstrap.setCatalinaBase(TOMCAT);
		} else {
			bootstrap.setCatalinaHome(tomcatDir);
			//bootstrap.setCatalinaBase(tomcatDir);
		}
		try {bootstrap.init();} catch (Exception e) {
			System.out.println("Exception during bootstrap.init()");
			System.out.println(e);
		}

		// Bootstrap.main(new String[0]);
	}

	public void runTomcat() throws Exception {
		
		bootstrap.setAwait(true);
		bootstrap.start();
	}

	public void stopTomcat() throws Exception {
		bootstrap.stop();
	}

	@Test
	public void testRunningANdStoppingTomcat() throws Exception {
		runTomcat();
		stopTomcat();

	}
	
	@Test
	public void testRunningTomcat() throws Exception {
		runTomcat();		
	}
	
	@Test
	public void testStoppingTomcat() throws Exception {		
		stopTomcat();
	}

	public static void main(String[] args) throws Exception {
		new StartAndStopTomcatTests().runTomcat();		
	}
}
